# copyright= 'Huynh Duong Phuong Vi @ 2013-2014'
# suforyou.vn@gmail.com
module S4U
	@s4u_menu=UI.menu("Plugins").add_submenu("Suforyou") if !@s4u_menu
	module S4u_makeface       
		Sketchup::require 'sketchup.rb' 
		Sketchup::require 'langhandler.rb'
		if not file_loaded?(NAME + "_menu")
			toolbar = UI::Toolbar.new("s4u-"+Strings.GetString(TOOL)) 
			names=[[Strings.GetString("Make Face"),"makeface1.png","makeface11.png",Strings.GetString("Select edges for Make Face")]]
			menu=S4U.instance_variable_get :@s4u_menu
			(0..names.length-1).each{|i|
				cmd=UI::Command.new(names[i][0]){ self.main }
				cmd.large_icon = names[i][1] 
				cmd.small_icon = names[i][2] 
				cmd.status_bar_text = names[i][3] 
				cmd.tooltip= names[i][0] 
				cmd.menu_text = names[i][0]
				toolbar=toolbar.add_item cmd 
				menu.add_item cmd
			}
			toolbar.show if toolbar.get_last_state.abs == 1 
		end
		def self.make_face(edges,status=false)
			eds=edges.grep(Sketchup::Edge)
			i=0;length=edges.length
			while (!eds.empty?) && i<length
				i+=1;f=[]
				ed=eds.shift
				if ed.find_faces>0  
					f=ed.faces.collect{|fa| fa.edges} 
					f.flatten!
					f.uniq!
					eds -= f.select{|fe| fe.faces.length>1}
				end
				Sketchup.status_text=(Strings.GetString("Make faces: ") + i.to_s) if status
			end
		end
		def self.main 
			model = Sketchup.active_model
			entities = model.active_entities
			model.start_operation Strings.GetString("Make Face"),true,false,false
			select=model.selection.grep(Sketchup::Edge)
			select1=select.clone          
			edge_select=[]
			i=0 ; length=select.length
			while !select.empty? && i<length
				i+=1
				last= select[0]
				ed=((last.start.edges + last.end.edges) & select1) - edge_select 
				if ed.length>0
					edge_select+=ed
					select-= ed
				end
			end       
			edges=edge_select.uniq            
			begin
				if edges.length>2   
					edge_remove=[]
					g=entities.add_group edges
					g_edge_remove=edges.select{|e| (e.start.edges.length==1 || e.end.edges.length==1)}
					j=0;length=edges.length                   
					while g_edge_remove.length>0 && j<length
						j+=1
						edges1=edges-g_edge_remove
						edge_remove+=g_edge_remove                       
						if edges1.length>0
							g.explode if g && g.valid? && !g.deleted?      
							edges=edges1.select{|e| (e.is_a?Sketchup::Edge) && e.valid? && !e.deleted?}
							g=entities.add_group edges
							g_edge_remove=edges.select{|e| (e.start.edges.length==1 || e.end.edges.length==1)}                           
						end
					end
					self.make_face(edges,true) if edges.length>0
					g.explode if g && g.valid? && !g.deleted?   
					model.selection.clear
					model.selection.add edge_remove.select{|e| (e.is_a?Sketchup::Edge) && e.valid? && !e.deleted?}
				end
			rescue
				puts "error"
			end
			model.commit_operation
		end
	end	
end